#|

 Gtk ffi

 Copyright (c) 2004 by Vasilis Margioulas <vasilism@sch.gr>

 You have the right to distribute and use this software as governed by 
 the terms of the Lisp Lesser GNU Public License (LLGPL):

    (http://opensource.franz.com/preamble.html)
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 Lisp Lesser GNU Public License for more details.
 
|#

(in-package :gtk-ffi)


(def-gtk-lib-functions :gtk
  ;;button
  (gtk-button-new ()
     c-pointer)
  (gtk-button-set-label ((button c-pointer)
			 (label c-string)))
  (gtk-button-set-relief ((button c-pointer)
			  (style int)))
  (gtk-button-set-use-stock ((button c-pointer)
			     (use-stock boolean)))
  ;;toggle-button
  (gtk-toggle-button-new ()
     c-pointer)
  (gtk-toggle-button-set-mode ((button c-pointer)
			       (draw-indicator boolean)))
  (gtk-toggle-button-set-active ((button c-pointer)(active boolean)))
  (gtk-toggle-button-get-active ((button c-pointer))
     boolean)
  ;;check-button
  (gtk-check-button-new ()
     c-pointer)
  ;;radio-button
  (gtk-radio-button-new ((gslist c-pointer))
     c-pointer)
  (gtk-radio-button-new-from-widget ((radio-group c-pointer))
     c-pointer)
  
  ;;spin-button
  (gtk-spin-button-new ((adjustment c-pointer)
			(climb-rate double-float)
			(digits uint))
    c-pointer)
  (gtk-spin-button-new-with-range ((minval double-float)
				   (maxval double-float)
				   (step double-float))
    c-pointer)
  (gtk-spin-button-set-value ((spin-button c-pointer)
			      (value double-float)))
  (gtk-spin-button-get-value ((spin-button c-pointer))
     double-float)
  (gtk-spin-button-get-value-as-int ((spin-button c-pointer))
     int)
  (gtk-spin-button-set-wrap ((spin-button c-pointer)
			     (wrap boolean))))

#+debugthis
(gtk-toggle-button-get-active ((button c-pointer))
     boolean)

#+not
(DEF-GTK-FUNCTION :GTK GTK-TOGGLE-BUTTON-GET-ACTIVE
                  :ARGUMENTS ((BUTTON C-POINTER))
                  :RETURN-TYPE BOOLEAN
                  :CALL-DIRECT T)

