#|

 Gtk ffi

 Copyright (c) 2004 by Vasilis Margioulas <vasilism@sch.gr>

 You have the right to distribute and use this software as governed by 
 the terms of the Lisp Lesser GNU Public License (LLGPL):

    (http://opensource.franz.com/preamble.html)
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 Lisp Lesser GNU Public License for more details.
 
|#

(in-package :gtk-ffi)


(def-gtk-lib-functions :gtk
  ;;toolbar
  (gtk-toolbar-new ()
    c-pointer)
  (gtk-toolbar-insert ((toolbar c-pointer)
		       (item c-pointer)
		       (pos int)))
  (gtk-toolbar-set-show-arrow ((toolbar c-pointer)
			       (show-arrow boolean)))
  (gtk-toolbar-set-orientation ((toolbar c-pointer)
				(orientation int)))
  (gtk-toolbar-set-tooltips ((toolbar c-pointer)
			     (enable boolean)))
  (gtk-toolbar-set-style ((toolbar c-pointer)
			  (style int)))

  ;;tooltips
  (gtk-tooltips-new ()
    c-pointer)
  (gtk-tooltips-set-tip ((tooltips c-pointer)
			 (widget c-pointer)
			 (tip-text c-string)
			 (tip-private c-string)))
  (gtk-tooltips-enable ((tooltips c-pointer)))
  (gtk-tooltips-disable ((tooltips c-pointer)))
  (gtk-tooltips-set-delay ((tooltips c-pointer)
			   (delay uint)))
  ;;tool-item
  (gtk-tool-item-new ()
    c-pointer)
  (gtk-tool-item-set-homogeneous ((tool-item c-pointer)
				  (homogeneous boolean)))
  (gtk-tool-item-set-expand ((tool-item c-pointer)
			     (expand boolean)))
  (gtk-tool-item-set-tooltip ((tool-item c-pointer)
			      (tooltips c-pointer)
			      (tip-text c-string)
			      (tip-private c-string)))
  (gtk-tool-item-set-is-important ((tool-item c-pointer)
				   (is-important boolean)))

  (gtk-separator-tool-item-new ()
     c-pointer)
  (gtk-separator-tool-item-set-draw ((item c-pointer)
				     (draw boolean)))

  ;;tool-button
  (gtk-tool-button-new ((icon-widget c-pointer)
			(label c-pointer))
    c-pointer)
  (gtk-tool-button-new-from-stock ((stock-id c-string))
    c-pointer)
  (gtk-tool-button-set-label ((tool-button c-pointer)
			      (label c-pointer)))
  (gtk-tool-button-set-use-underline ((tool-button c-pointer)
				      (use-underline boolean)))
  (gtk-tool-button-set-stock-id ((tool-button c-pointer)
				 (stock-id c-string)))
  (gtk-tool-button-set-icon-widget ((tool-button c-pointer)
				    (icon-widget c-pointer)))
  (gtk-tool-button-set-label-widget ((tool-button c-pointer)
				     (label-widget c-pointer))))
  
